internal.h File Reference

Go to the source code of this file.

## Data Structures

struct | rb_deprecated_classext_struct
struct | rb_classext_struct

## Macros

#define | RCLASS_EXT(c) (RCLASS(c)->ptr)
#define | RCLASS_SUPER(c) (RCLASS_EXT(c)->super)
#define | RCLASS_IV_TBL(c) (RCLASS_EXT(c)->iv_tbl)
#define | RCLASS_CONST_TBL(c) (RCLASS_EXT(c)->const_tbl)
#define | RCLASS_M_TBL(c) (RCLASS(c)->m_tbl)
#define | RCLASS_IV_INDEX_TBL(c) (RCLASS(c)->iv_index_tbl)
#define | RCLASS_EXT(c) (RCLASS(c)->ptr)
#define | RCLASS_SUPER(c) (RCLASS_EXT(c)->super)
#define | RCLASS_IV_TBL(c) (RCLASS_EXT(c)->iv_tbl)
#define | RCLASS_CONST_TBL(c) (RCLASS_EXT(c)->const_tbl)
#define | RCLASS_M_TBL(c) (RCLASS(c)->m_tbl)
#define | RCLASS_IV_INDEX_TBL(c) (RCLASS(c)->iv_index_tbl)
#define | RCLASS_EXT(c) (RCLASS(c)->ptr)
#define | RCLASS_SUPER(c) (RCLASS_EXT(c)->super)
#define | RCLASS_IV_TBL(c) (RCLASS_EXT(c)->iv_tbl)
#define | RCLASS_CONST_TBL(c) (RCLASS_EXT(c)->const_tbl)
#define | RCLASS_M_TBL(c) (RCLASS(c)->m_tbl)
#define | RCLASS_IV_INDEX_TBL(c) (RCLASS(c)->iv_index_tbl)

## Functions

VALUE | rb_ary_last (int, VALUE *, VALUE)
VALUE | rb_big_fdiv (VALUE x, VALUE y)
VALUE | rb_big_uminus (VALUE x)
VALUE | rb_obj_methods (int argc, VALUE *argv, VALUE obj)
VALUE | rb_obj_protected_methods (int argc, VALUE *argv, VALUE obj)
VALUE | rb_obj_private_methods (int argc, VALUE *argv, VALUE obj)
VALUE | rb_obj_public_methods (int argc, VALUE *argv, VALUE obj)
int | rb_obj_basic_to_s_p (VALUE)
void | Init_class_hierarchy (void)
int | rb_dvar_defined (ID)
int | rb_local_defined (ID)
int | rb_parse_in_eval (void)
int | rb_parse_in_main (void)
VALUE | rb_insns_name_array (void)
VALUE | rb_obj_is_fiber (VALUE)
void | rb_fiber_reset_root_local_storage (VALUE)
| PRINTF_ARGS (void ruby_debug_printf(const char *,...), 1, 2)
void | Init_ext (void)
ID | rb_id_encoding (void)
void | rb_gc_mark_encodings (void)
| NORETURN (PRINTF_ARGS(void rb_compile_bug(const char *, int, const char *,...), 3, 4))
VALUE | rb_check_backtrace (VALUE)
| NORETURN (void rb_async_bug_errno(const char *, int))
void | ruby_error_print (void)
VALUE | rb_get_backtrace (VALUE info)
void | rb_call_end_proc (VALUE data)
VALUE | rb_home_dir (const char *user, VALUE result)
VALUE | rb_realpath_internal (VALUE basedir, VALUE path, int strict)
void | Init_File (void)
void | Init_heap (void)
void | rb_call_inits (void)
const char * | ruby_get_inplace_mode (void)
void | ruby_set_inplace_mode (const char *)
ssize_t | rb_io_bufread (VALUE io, void *buf, size_t size)
void | rb_stdio_set_default_encoding (void)
VALUE | rb_iseq_compile_with_option (VALUE src, VALUE file, VALUE filepath, VALUE line, VALUE opt)
VALUE | rb_iseq_clone (VALUE iseqval, VALUE newcbase)
VALUE | rb_get_load_path (void)
VALUE | rb_math_atan2 (VALUE, VALUE)
VALUE | rb_math_cos (VALUE)
VALUE | rb_math_cosh (VALUE)
VALUE | rb_math_exp (VALUE)
VALUE | rb_math_hypot (VALUE, VALUE)
VALUE | rb_math_log (int argc, VALUE *argv)
VALUE | rb_math_sin (VALUE)
VALUE | rb_math_sinh (VALUE)
VALUE | rb_math_sqrt (VALUE)
void | Init_newline (void)
int | rb_num_to_uint (VALUE val, unsigned int *ret)
int | ruby_float_step (VALUE from, VALUE to, VALUE step, int excl)
double | ruby_float_mod (double x, double y)
VALUE | rb_obj_equal (VALUE obj1, VALUE obj2)
VALUE | rb_parser_get_yydebug (VALUE)
VALUE | rb_parser_set_yydebug (VALUE, VALUE)
VALUE | rb_proc_location (VALUE self)
VALUE | rb_lcm (VALUE x, VALUE y)
VALUE | rb_rational_reciprocal (VALUE x)
VALUE | rb_reg_compile (VALUE str, int options, const char *sourcefile, int sourceline)
VALUE | rb_reg_check_preprocess (VALUE)
int | rb_get_next_signal (void)
size_t | rb_strftime_timespec (char *s, size_t maxsize, const char *format, const struct vtm *vtm, struct timespec *ts, int gmt)
int | rb_str_buf_cat_escaped_char (VALUE result, unsigned int c, int unicode_p)
VALUE | rb_struct_init_copy (VALUE copy, VALUE s)
struct timeval | rb_time_timeval (VALUE)
VALUE | rb_obj_is_mutex (VALUE obj)
VALUE | ruby_suppress_tracing (VALUE(*func)(VALUE, int), VALUE arg, int always)
void | rb_thread_execute_interrupts (VALUE th)
void | rb_clear_trace_func (void)
VALUE | rb_thread_backtrace (VALUE thval)
VALUE | rb_get_coverages (void)
void | Init_native_thread (void)
VALUE | rb_obj_is_thread (VALUE obj)
void | rb_vm_mark (void *ptr)
void | Init_BareVM (void)
VALUE | rb_vm_top_self (void)
void | rb_thread_recycle_stack_release (VALUE *)
void | rb_vm_change_state (void)
void | rb_vm_inc_const_missing_count (void)
void | rb_thread_mark (void *th)
const void ** | rb_vm_get_insns_address_table (void)
void | rb_vm_bugreport (void)
void | Init_vm_eval (void)
VALUE | rb_current_realfilepath (void)
void | Init_eval_method (void)
void | Init_prelude (void)
const char * | rb_objspace_data_type_name (VALUE obj)
VALUE | rb_thread_io_blocking_region (rb_blocking_function_t *func, void *data1, int fd)
void * | rb_thread_call_with_gvl (void *(*func)(void *), void *data1)
VALUE | rb_thread_call_without_gvl (rb_blocking_function_t *func, void *data1, rb_unblock_function_t *ubf, void *data2)

## Macro Definition Documentation

#define RCLASS_CONST_TBL | ( |  | c | ) | (RCLASS_EXT(c)->const_tbl)

Definition at line 57 of file ripper.y.

Referenced by autoload_delete(), autoload_node_id(), class_alloc(), fc_i(), find_class_path(), gc_mark_children(), include_class_new(), init_copy(), obj_free(), rb_autoload(), rb_const_defined_0(), rb_const_get_0(), rb_const_remove(), rb_const_set(), rb_mod_const_at(), rb_mod_init_copy(), rb_singleton_class_clone(), set_const_visibility(), and vm_get_ev_const().

#define RCLASS_CONST_TBL | ( |  | c | ) | (RCLASS_EXT(c)->const_tbl)

Definition at line 36 of file internal.h.

#define RCLASS_CONST_TBL | ( |  | c | ) | (RCLASS_EXT(c)->const_tbl)

Definition at line 57 of file parse.y.

#define RCLASS_EXT | ( |  | c | ) | (RCLASS(c)->ptr)

Definition at line 54 of file ripper.y.

#define RCLASS_EXT | ( |  | c | ) | (RCLASS(c)->ptr)

Definition at line 33 of file internal.h.

#define RCLASS_EXT | ( |  | c | ) | (RCLASS(c)->ptr)

Definition at line 54 of file parse.y.

#define RCLASS_IV_INDEX_TBL | ( |  | c | ) | (RCLASS(c)->iv_index_tbl)

Definition at line 59 of file parse.y.

#define RCLASS_IV_INDEX_TBL | ( |  | c | ) | (RCLASS(c)->iv_index_tbl)

Definition at line 38 of file internal.h.

#define RCLASS_IV_INDEX_TBL | ( |  | c | ) | (RCLASS(c)->iv_index_tbl)

Definition at line 59 of file ripper.y.

Referenced by class_alloc(), memsize_of(), obj_free(), and rb_ivar_set().

#define RCLASS_IV_TBL | ( |  | c | ) | (RCLASS_EXT(c)->iv_tbl)

Definition at line 56 of file parse.y.

#define RCLASS_IV_TBL | ( |  | c | ) | (RCLASS_EXT(c)->iv_tbl)

Definition at line 35 of file internal.h.

#define RCLASS_IV_TBL | ( |  | c | ) | (RCLASS_EXT(c)->iv_tbl)

Definition at line 56 of file ripper.y.

Referenced by autoload_delete(), autoload_node(), class_alloc(), classname(), fc_path(), find_class_path(), gc_mark_children(), include_class_new(), init_copy(), ivar_get(), memsize_of(), obj_free(), rb_autoload(), rb_class_path(), rb_cvar_get(), rb_cvar_set(), rb_ivar_count(), rb_ivar_defined(), rb_ivar_foreach(), rb_ivar_set(), rb_mod_class_variables(), rb_mod_init_copy(), rb_mod_remove_cvar(), rb_obj_remove_instance_variable(), rb_singleton_class_attached(), rb_singleton_class_clone(), and w_extended().

#define RCLASS_M_TBL | ( |  | c | ) | (RCLASS(c)->m_tbl)

Definition at line 58 of file ripper.y.

Referenced by add_opt_method(), class_alloc(), class_instance_method_list(), gc_mark_children(), include_class_new(), memsize_of(), obj_free(), rb_class_boot(), rb_class_inherited_p(), rb_include_module(), rb_method_entry_make(), rb_mod_init_copy(), rb_module_new(), rb_obj_is_kind_of(), rb_obj_singleton_methods(), rb_singleton_class_clone(), remove_method(), search_method(), and w_extended().

#define RCLASS_M_TBL | ( |  | c | ) | (RCLASS(c)->m_tbl)

Definition at line 58 of file parse.y.

#define RCLASS_M_TBL | ( |  | c | ) | (RCLASS(c)->m_tbl)

Definition at line 37 of file internal.h.

#define RCLASS_SUPER | ( |  | c | ) | (RCLASS_EXT(c)->super)

Definition at line 55 of file ripper.y.

Referenced by class_alloc(), class_instance_method_list(), gc_mark_children(), include_class_new(), make_metaclass(), mnew(), rb_alias(), rb_autoload_p(), rb_class_boot(), rb_class_get_superclass(), rb_class_inherited_p(), rb_class_init_copy(), rb_class_initialize(), rb_class_real(), rb_class_superclass(), rb_const_defined_0(), rb_const_get_0(), rb_define_class(), rb_define_class_id_under(), rb_include_module(), rb_mod_ancestors(), rb_mod_const_of(), rb_mod_include_p(), rb_mod_included_modules(), rb_mod_init_copy(), rb_mod_modfunc(), rb_obj_alloc(), rb_obj_is_kind_of(), rb_obj_singleton_methods(), rb_singleton_class_clone(), search_method(), struct_ivar_get(), vm_call0(), vm_call_method(), vm_call_super(), vm_search_const_defined_class(), vm_search_normal_superclass(), and w_extended().

#define RCLASS_SUPER | ( |  | c | ) | (RCLASS_EXT(c)->super)

Definition at line 55 of file parse.y.

#define RCLASS_SUPER | ( |  | c | ) | (RCLASS_EXT(c)->super)

Definition at line 34 of file internal.h.

## Function Documentation

void Init_BareVM | ( | void |  | ) |

Definition at line 2202 of file vm.c.

void Init_eval_method | ( | void |  | ) |

Definition at line 1282 of file vm_method.c.

void Init_ext | ( | void |  | ) |

Definition at line 2 of file dmyext.c.

void Init_File | ( | void |  | ) |

Definition at line 5284 of file file.c.

void Init_heap | ( | void |  | ) |

Definition at line 2589 of file gc.c.

void Init_native_thread | ( | void |  | ) |

void Init_newline | ( | void |  | ) |

Definition at line 183 of file newline.c.

void Init_prelude | ( | void |  | ) |

Definition at line 56 of file miniprelude.c.

void Init_vm_eval | ( | void |  | ) |

Definition at line 1775 of file vm_eval.c.

NORETURN | ( | PRINTF_ARGS(void rb_compile_bug(const char *, int, const char *,...), 3, 4) |  | ) |

NORETURN | ( | void | rb_async_bug_errnoconst char *, int | ) |

PRINTF_ARGS | ( | void | ruby_debug_printfconst char *,...,
|  | 1 | ,
|  | 2 |
| ) |  |

VALUE rb_ary_last | ( | int | ,
|  | VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 1089 of file array.c.

VALUE rb_big_fdiv | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 3004 of file bignum.c.

VALUE rb_big_uminus | ( | VALUE | x | ) |

Definition at line 1646 of file bignum.c.

void rb_call_end_proc | ( | VALUE | data | ) |

Definition at line 11 of file eval_jump.c.

void rb_call_inits | ( | void |  | ) |

Definition at line 18 of file inits.c.

VALUE rb_check_backtrace | ( | VALUE |  | ) |

Definition at line 659 of file error.c.

void rb_clear_trace_func | ( | void |  | ) |

Definition at line 4337 of file thread.c.

VALUE rb_current_realfilepath | ( | void |  | ) |

Definition at line 1765 of file vm_eval.c.

int rb_dvar_defined | ( | ID |  | ) |

Definition at line 5525 of file compile.c.

void rb_fiber_reset_root_local_storage | ( | VALUE |  | ) |

Definition at line 1357 of file cont.c.

void rb_gc_mark_encodings | ( | void |  | ) |

Definition at line 186 of file encoding.c.

VALUE rb_get_backtrace | ( | VALUE | info | ) |

Definition at line 53 of file eval_error.c.

VALUE rb_get_coverages | ( | void |  | ) |

Definition at line 4817 of file thread.c.

VALUE rb_get_load_path | ( | void |  | ) |

Definition at line 31 of file load.c.

int rb_get_next_signal | ( | void |  | ) |

Definition at line 546 of file signal.c.

VALUE rb_home_dir | ( | const char * | user,
|  | VALUE | result
| ) |  |

Definition at line 2812 of file file.c.

ID rb_id_encoding | ( | void |  | ) |

Definition at line 644 of file encoding.c.

VALUE rb_insns_name_array | ( | void |  | ) |

Definition at line 5206 of file compile.c.

ssize_t rb_io_bufread | ( | VALUE | io,
|  | void * | buf,
|  | size_t | size
| ) |  |

Definition at line 1767 of file io.c.

VALUE rb_iseq_compile_with_option | ( | VALUE | src,
|  | VALUE | file,
|  | VALUE | filepath,
|  | VALUE | line,
|  | VALUE | opt
| ) |  |

Definition at line 550 of file iseq.c.

VALUE rb_lcm | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 1664 of file rational.c.

int rb_local_defined | ( | ID |  | ) |

Definition at line 5550 of file compile.c.

VALUE rb_math_atan2 | ( | VALUE | ,
|  | VALUE |
| ) |  |

VALUE rb_math_cos | ( | VALUE |  | ) |

VALUE rb_math_cosh | ( | VALUE |  | ) |

VALUE rb_math_exp | ( | VALUE |  | ) |

VALUE rb_math_hypot | ( | VALUE | ,
|  | VALUE |
| ) |  |

VALUE rb_math_log | ( | int | argc,
|  | VALUE * | argv
| ) |  |

VALUE rb_math_sin | ( | VALUE |  | ) |

VALUE rb_math_sinh | ( | VALUE |  | ) |

VALUE rb_math_sqrt | ( | VALUE |  | ) |

int rb_num_to_uint | ( | VALUE | val,
|  | unsigned int * | ret
| ) |  |

Definition at line 121 of file numeric.c.

VALUE rb_obj_equal | ( | VALUE | obj1,
|  | VALUE | obj2
| ) |  |

Definition at line 95 of file object.c.

VALUE rb_obj_is_fiber | ( | VALUE |  | ) |

Definition at line 328 of file cont.c.

VALUE rb_obj_is_mutex | ( | VALUE | obj | ) |

Definition at line 3392 of file thread.c.

VALUE rb_obj_is_thread | ( | VALUE | obj | ) |

Definition at line 1840 of file vm.c.

const char* rb_objspace_data_type_name | ( | VALUE | obj | ) |

Definition at line 1258 of file gc.c.

int rb_parse_in_eval | ( | void |  | ) |

Definition at line 5569 of file compile.c.

int rb_parse_in_main | ( | void |  | ) |

Definition at line 5575 of file compile.c.

VALUE rb_parser_get_yydebug | ( | VALUE |  | ) |

Definition at line 16567 of file ripper.c.

VALUE rb_parser_set_yydebug | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 16582 of file ripper.c.

VALUE rb_proc_location | ( | VALUE | self | ) |

Definition at line 709 of file proc.c.

VALUE rb_rational_reciprocal | ( | VALUE | x | ) |

Definition at line 1624 of file rational.c.

VALUE rb_realpath_internal | ( | VALUE | basedir,
|  | VALUE | path,
|  | int | strict
| ) |  |

Definition at line 3341 of file file.c.

VALUE rb_reg_check_preprocess | ( | VALUE |  | ) |

Definition at line 2289 of file re.c.

VALUE rb_reg_compile | ( | VALUE | str,
|  | int | options,
|  | const char * | sourcefile,
|  | int | sourceline
| ) |  |

Definition at line 2516 of file re.c.

void rb_stdio_set_default_encoding | ( | void |  | ) |

Definition at line 9553 of file io.c.

int rb_str_buf_cat_escaped_char | ( | VALUE | result,
|  | unsigned int | c,
|  | int | unicode_p
| ) |  |

Definition at line 4346 of file string.c.

size_t rb_strftime_timespec | ( | char * | s,
|  | size_t | maxsize,
|  | const char * | format,
|  | const struct vtm * | vtm,
|  | struct timespec * | ts,
|  | int | gmt
| ) |  |

Definition at line 791 of file strftime.c.

VALUE rb_struct_init_copy | ( | VALUE | copy,
|  | VALUE | s
| ) |  |

Definition at line 590 of file struct.c.

VALUE rb_thread_backtrace | ( | VALUE | thval | ) |

Definition at line 1646 of file vm_eval.c.

void* rb_thread_call_with_gvl | ( | void *(*)(void *) | func,
|  | void * | data1
| ) |  |

Definition at line 1199 of file thread.c.

VALUE rb_thread_call_without_gvl | ( | rb_blocking_function_t * | func,
|  | void * | data1,
|  | rb_unblock_function_t * | ubf,
|  | void * | data2
| ) |  |

Definition at line 1159 of file thread.c.

void rb_thread_execute_interrupts | ( | VALUE | th | ) |

Definition at line 1339 of file thread.c.

VALUE rb_thread_io_blocking_region | ( | rb_blocking_function_t * | func,
|  | void * | data1,
|  | int | fd
| ) |  |

Definition at line 1139 of file thread.c.

void rb_thread_mark | ( | void * | th | ) |

Definition at line 1706 of file vm.c.

void rb_thread_recycle_stack_release | ( | VALUE * |  | ) |

Definition at line 1684 of file vm.c.

struct timeval rb_time_timeval | ( | VALUE |  | ) |

read

Definition at line 2442 of file time.c.

void rb_vm_bugreport | ( | void |  | ) |

Definition at line 770 of file vm_dump.c.

void rb_vm_change_state | ( | void |  | ) |

Definition at line 63 of file vm.c.

const void** rb_vm_get_insns_address_table | ( | void |  | ) |

Definition at line 116 of file vm_exec.c.

void rb_vm_inc_const_missing_count | ( | void |  | ) |

Definition at line 88 of file vm.c.

void rb_vm_mark | ( | void * | ptr | ) |

Definition at line 1564 of file vm.c.

VALUE rb_vm_top_self | ( | void |  | ) |

Definition at line 2236 of file vm.c.

void ruby_error_print | ( | void |  | ) |

Definition at line 187 of file eval_error.c.

double ruby_float_mod | ( | double | x,
|  | double | y
| ) |  |

Definition at line 846 of file numeric.c.

int ruby_float_step | ( | VALUE | from,
|  | VALUE | to,
|  | VALUE | step,
|  | int | excl
| ) |  |

Definition at line 1689 of file numeric.c.

const char* ruby_get_inplace_mode | ( | void |  | ) |

Definition at line 10513 of file io.c.

void ruby_set_inplace_mode | ( | const char * |  | ) |

Definition at line 10519 of file io.c.

VALUE ruby_suppress_tracing | ( | VALUE(*)(VALUE, int) | func,
|  | VALUE | arg,
|  | int | always
| ) |  |

Definition at line 4538 of file thread.c.